#include "c3po.h"

void loadSymbols() {
    c3po.init = dlsym(c3po.library, "init");
    c3po.destroy = dlsym(c3po.library, "destroy");

    return;
}

void reload(int signal) {
    (c3po.destroy)(c3po.handle);
    dlclose(c3po.library);

    if((c3po.library = dlopen("base/config.so", RTLD_NOW | RTLD_GLOBAL)) == NULL) {
        fprintf(stderr, "Fatal Err: base/config.so is no longer loadable.\n");
        exit(-1);
    }

    c3po.handle = (c3po.init)();

    exit(-1);
    return;
}

int main(int argc, char** argv) {
    signal(SIGUSR1, reload);
    signal(SIGSEGV, reload);

    if((c3po.library = dlopen("base/config.so", RTLD_NOW | RTLD_GLOBAL)) == NULL) {
        fprintf(stderr, "Fatal Err: Unable to load base/config.so. c3po is nothing without it\n");
        return -1;
    }

    loadSymbols();
    c3po.handle = (c3po.init)();

    fprintf(stderr, "init() returned. This shouldn't be possible.\n");

    return -1;
}
